'use strict';

var babelPluginJsxDomExpressions = require('babel-plugin-jsx-dom-expressions');
var solidJs = require('solid-js');

let runtime;
var index = runtime = babelPluginJsxDomExpressions.createRuntime({
  wrap(accessor, el, isAttr, fn, deep) {
    solidJs.S.makeComputationNode(() => {
      let value = accessor();
      if ((value != null) && value instanceof Object) {
        if (typeof value === 'function' && !isAttr && !deep) {
          runtime.wrap(value, el, isAttr, fn, true);
          return;
        }
        if ('subscribe' in value) {
          const dispose = value.subscribe((value) => fn(value, el));
          solidJs.S.cleanup('unsubscribe' in dispose ? dispose.unsubscribe.bind(dispose) : dispose);
          return;
        }
        if ('then' in value) {
          let released = false;
          value.then((value) => released ? void 0 : fn(value, el));
          solidJs.S.cleanup(() => released = true);
          return;
        }
        if (isAttr) value = solidJs.unwrap(value);
      }
      solidJs.S.sample(() => fn(value, el));
    });
  }
});

module.exports = index;
